function [ coordinates,dimension,numberofcells,walls,wall2cell,Wallbnd,l_n,Cellarea,CellvertexId,epiId,hypoId,stoneId]=CVT(x,y)
Wallbnd=[];
epiId=[];
hypoId=[];
stoneId=[];
% centroids=handles.centroids;
% area=handles.area;
% perimeter=handles.perimeter;
% Aspectratio=handles.Aspectratio;
% orientation=handles.orientation;

rand('state',2);
numcell=1;
 x = sqrt(600*numcell)*rand(numcell,1);
 y = sqrt(600*numcell)*rand(numcell,1);
 
centroids=[x,y];
% xmax=max(x);
% ymax=max(y);

xxmin=0; 
xxmax=sqrt(600*numcell);

yymin=0; 
yymax=sqrt(600*numcell);

n=length(centroids);
Bc=zeros(n,2);


xmin=0; 
xmax=sqrt(600*numcell);

ymin=0; 
ymax=sqrt(600*numcell);

% axis ([xmin xmax ymin ymax])
iteration=1;
%% iteration for generating the centroidal Voronoi cells
figure(1)
while sum(((centroids(:,1)-Bc(:,1)).*(centroids(:,1)-Bc(:,1)))/n)+sum(((centroids(:,2)-Bc(:,2)).*(centroids(:,2)-Bc(:,2)))/n)> [0.005]

    BB=[centroids(:,1),centroids(:,2);-centroids(:,1),centroids(:,2)...
    ;centroids(:,1),-centroids(:,2);xmax+(xmax-centroids(:,1)),centroids(:,2)...
    ; centroids(:,1),ymax+(ymax-centroids(:,2))];

    centroids2=[ ];
    area2=[ ];
    perimeter2=[ ];   % initialization of voronoi properties
    angle2=[ ];
    Aspectratio2=[ ];


    [V,C]=voronoin(BB);

    for j=1:length(C)
 
        X = V(C{j},:);


        if ~isinf(X)

            % calculating  area and centroid of the voronoi region

            x0=mean(X(:,1));
            y0=mean(X(:,2));

            centroids2=[ centroids2; x0 y0];

            % However, we are not interested in the centroids here any more;we use
            % random generators

            
        end
 
    end

%% selecting properties in the range of interest

    B=[centroids2];

    % centroidal points in the region of interest

    
[Id,d]=nearestpoint(centroids(:,1),BB(:,1));
B0=B(Id,1:2);
    % area of voronoi regions of interest

    

    Bc=centroids;
    centroids= B0;
     clc
    iteration=iteration+1;
    sum(((centroids-Bc).*(centroids-Bc))/n)
   
end

%% constructing voronoi diagrams
Centroids=[centroids(:,1),centroids(:,2);xxmin-centroids(:,1),centroids(:,2)...
    ;centroids(:,1),yymin-centroids(:,2);xxmax+(xxmax-centroids(:,1)),centroids(:,2)...
    ; centroids(:,1),yymax+(yymax-centroids(:,2))];
[V,C]=voronoin(Centroids);
[vx,vy]=voronoi(Centroids(:,1),Centroids(:,2));

% figure(1);
% plot(Centroids(:,1),Centroids(:,2),'.',vx,vy,'r-')
%  axis([xmin xmax ymin ymax]);
%   axis([-3 3 -3 3]);
X1=[];
z=[];


for j=1:length(C)
   if ((((V(C{j},1)>xmin-0.0001))& (V(C{j},1)<xmax+0.00001)))&(((V(C{j},2)>ymin-0.000010)& (V(C{j},2)<ymax+0.00001))),
    X = V(C{j},:) ;                   %voronoi vertices 
    
     
    
    if ~isinf(X)
        figure(1)
    X=[[X(:,1) ; X(1,1)],[X(:,2) ; X(1,2)]];       % closing the voronoi diagram
    X0=mean(X(:,1));
    Y0=mean(X(:,2));
    
    patch(X(:,1),X(:,2),'w')
    hold on
%       axis([-3000 4000 -3000 4000]);
     
    end
    X1=[X1;X];
    V0{j}=X;
    
   
   end
    
end
no_neighbors=[ ];
distribution=[ ];
dis_x=[ ];
dis_y=[ ];
index=[ ];
index11=[];
for i=1:length(V0)
    index1=[ ];
     coord_cell=V0{i};
    for j=1:length(V0)
        if ~isequal(i,j)
            neighbor=intersect(coord_cell, V0{j},'rows');
            if ~isempty(neighbor)
                index1=[index1; i j];                        % pair of neighbor cells
                dis_x1= sqrt((centroids(i,1)-centroids(j,1))^2 );
                dis_y1=sqrt((centroids(i,2)-centroids(j,2))^2);
                dis_x=[dis_x;dis_x1];
                dis_y=[dis_y;dis_y1];
                index=[index; j];                            % neighbour cells to a given cell i
                index11=[index11;index1];
                NN{i}=index1;
            end
        end
    end
    neighbors{i}=[index, dis_x, dis_y];                      % neighbors and intercentroidal distances
    no_neighbors=[no_neighbors;length(index1)];
end
index_unic=unique(index11,'rows');
% [X_unic,x_unic,y_unic]=unique(X1(:),'rows');

 
[Id,d]=nearestpoint(centroids(:,1),Centroids(:,1));
M2=[];

for i=1:length(Id),
    V1=V0{Id(i)};
    counter=0;
    for k=1:length(V0);
        for h=1:length(V0{k}),
            counter=counter+1;
           
            cordinates(counter,1)=V0{k}(h,1);
            cordinates(counter,2)=V0{k}(h,2);
           
        end
    
    end
%     figure(6)
%     patch(V1(:,1),V1(:,2),'g');
%     hold on
%     axis([-0 1 -0 1]);
    vertex{i}=V1;
    
    M2=[M2;vertex{i}];

end
figure(1)
plot(centroids(:,1),centroids(:,2),'*')
hold on
[coordinates,I,J]=unique(cordinates,'rows');
Coordinates=coordinates;
%% wall2vertex specification
counter=0;
for i=1:length(V0),
for j=1:length(V0{i}),
counter=counter+1;
if j<length(V0{i}),
Walls(counter,1)=J(counter);
Walls(counter,2)=J(counter+1);
end
end
end
for i=1:length(Walls),
for j=2:length(Walls),

    if Walls(j,1)==Walls(i,2)&Walls(j,2)==Walls(i,1)
Walls(j,:)=0;
    end
end

end

[I,L,WAll1]=find(Walls(:,1));
[I,L,WAll2]=find(Walls(:,2));
Wall=[WAll1,WAll2];
Walls= unique(Wall,'rows');
for i=1:length(Walls),
    if ((abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1)))>abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2))))&(coordinates(Walls(i,1),1))>coordinates(Walls(i,2),1))...
            |((abs((coordinates(Walls(i,2),2)-coordinates(Walls(i,1),2)))>abs((coordinates(Walls(i,2),1)-coordinates(Walls(i,1),1))))&(coordinates(Walls(i,1),2))>coordinates(Walls(i,2),2)),
   wall(i,1)=Walls(i,2);
  wall(i,2)=Walls(i,1);
    else
        wall(i,1)=Walls(i,1);
        wall(i,2)=Walls(i,2);
    end
end

walls=wall;


%% initializing length of cells
for i=1:length(walls)
l(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);
l_n(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);
end

 
        
numberofcells=length(V0)+1;


 %% wall2cell specification

for i=1:length(walls),
    for j=1:length(V0),
       QQ1=intersect(coordinates(walls(i,1),:),V0{j},'rows');
    QQ2=intersect(coordinates(walls(i,2),:),V0{j},'rows');
    if (~isempty(QQ1)&~isempty(QQ2))
       Wall_vector= [coordinates(walls(i,2),:)-coordinates(walls(i,1),:),0];
       CellPos_vector=[[mean(V0{j}(:,1)),mean(V0{j}(:,2))]-coordinates(walls(i,1),:),0];
       angle=cross( Wall_vector,CellPos_vector);
       if angle(3)>0,
           wall2cell(i,1)=j;
       elseif angle(3)<0
           wall2cell(i,2)=j;
       end
    end
    end
    
%    
end


for i=1:length(wall2cell),
   if wall2cell(i,1)==0,
  wall2cell(i,1)=numberofcells;
   end
if wall2cell(i,2)==0,
  wall2cell(i,2)=numberofcells;
   end


end
ba=find( wall2cell(:,1)==numberofcells| wall2cell(:,2)==numberofcells);
   Wall2cell=wall2cell(ba,:);
   
   Wallb=wall(ba,:);
%% cellvertexId and cell area specification
counter=0;
for i=1:length(V0),
for j=1:length(V0{i}),
counter=counter+1;

CellvertexId{i}(j)=J(counter);

end
end
for k=1:length(CellvertexId),
    CellvertexId{k}=unique(CellvertexId{k});
    centroid{k}=mean(coordinates(CellvertexId{k}(:),:));
    thetarad{k}=atan2((coordinates(CellvertexId{k}(:),2)-centroid{k}(2)),(coordinates(CellvertexId{k}(:),1)-centroid{k}(1)));
    thetaneg=find(thetarad{k}<0);
    thetarad{k}(thetaneg(:))=thetarad{k}(thetaneg(:))+2*pi;
    [Y,I] = sort(thetarad{k});
    CelvertexId{k}=CellvertexId{k};
    CellvertexId{k}=CelvertexId{k}(I);
   CellvertexId{k}=[CellvertexId{k}(:);CellvertexId{k}(1)]';
     

   
end
for i=1:length( CellvertexId),
   
 Cellarea(i)=polyarea(coordinates(CellvertexId{i}(:),1),coordinates(CellvertexId{i}(:),2));
  end

%=====================
dimension=2;
numberofwalls=length(walls);
l_n=zeros(numberofwalls,1);
l=zeros(numberofwalls,1);
for i=1:1:numberofwalls,
   l_n(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);      %l_n(i)=sqrt((coordinates(walls(i,1),1)-coordinates(walls(i,2),1))^2+(coordinates(walls(i,1),2)-coordinates(walls(i,2),2))^2);
   l(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);
end
for i=1:length(walls)
       bb(walls(i,1),walls(i,2))=1;
end
   h=figure(10);
% patch(XY1(KK),XY2(KK),'m')
hold on
for i=1:length(CellvertexId)
patch(coordinates(CellvertexId{i}(:),1),coordinates(CellvertexId{i}(:),2),'g');
%  text(x0(i),y0(i),[strcat('c_',num2str(i))],'FontSize',10)
hold on
axis('equal')
axis([00 max(coordinates(:,1)) 00 max(coordinates(:,2))])   %    axis([0 130 0 130]);
  
 
end
   end


