function [ coordinates,dimension,numberofcells,walls,wall2cell,Wallbnd,l_n,Cellarea,CellvertexId,epiId,hypoId,paliId,stoneId,wallvepiuper,oldwall,adhesive_wall,adw,WO_1,WO_2,...
    ad_direction,old_cord,split_wall,split_turgor_1,split_turgor_2,con_point,con_point_2,con_point_3]=doublewalls(geom,numcell,string, string11);

% geom=2 % uncomment this and select a number so that the initial tesselation for spongy cells is kept the same among geometries

[ coordinates,dimension,numberofcells,walls,wall2cell,Wallbnd,l_n,Cellarea,CellvertexId,epiId,hypoId,paliId,stoneId,wallvepiuper,oldwall]=starttesselation(geom,numcell);

old_cord=length(coordinates);

left_boundary=[];
right_boundary=[];
bottom_boundaryy=[];
top_boundaryy=[];
for i=1:length(coordinates)
    if abs(coordinates(i,1)-min(coordinates(:,1)))<0.00001
        left_boundary=[left_boundary,i];
    end
    if abs(coordinates(i,1)-max(coordinates(:,1)))<0.00001
        right_boundary=[right_boundary,i];
    end

    if abs(coordinates(i,2)-min(coordinates(:,2)))<0.00001
        bottom_boundaryy=[bottom_boundaryy,i];
    end
    if abs(coordinates(i,2)-max(coordinates(:,2)))<0.00001
        top_boundaryy=[top_boundaryy,i];
    end
end

    %% 
    cord=[];
    wall=[];
    w2c=[];
    CellID=[];
    wall=walls;
    w2c=wall2cell;
    CellID=CellvertexId;
    cord=coordinates;
    AA=[];
    BB=[];
    adhesive_wall=[];
    WO_1=[];
    WO_2=[];
    split_wall=[];
    con_point=[];
    con_point_2=[];
    con_point_3=[];
    split_turgor_1=[];
    split_turgor_2=[];
      
    con_point_pal=[];
    con_point_2_pal=[];
    con_point_3_pal=[];
      
    con_point_epi=[];
    con_point_2_epi=[];
    con_point_3_epi=[];
      
    con_point_spongy=[];
    con_point_2_spongy=[];
    con_point_3_spongy=[];
      
    con_point_pal_spongy=[];
    con_point_2_pal_spongy=[];
    con_point_3_pal_spongy=[];
      

     for i=1:length(walls)
        if (~ismember(numberofcells,wall2cell(i,:)))%&(ismember(wall2cell(i,1),paliId)|ismember(wall2cell(i,2),paliId))

          % update coordinates
          cord_before=length(cord);
           if ~ismember(walls(i,1),AA)
           cord(walls(i,1),:)=coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,1)},:)));
            end
          if ~ismember(walls(i,2),AA)
           cord(walls(i,2),:)=coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,1)},:)));
          end
    
              
            
          ab1=[];
          ad11=[];
          ad1=[];
          ad33=[];
          ad_33=[];
          an=[];
          ar=[];
          am1=[];
          am2=[];
              for j=1:length(cord)-length(coordinates)
                  
                  ad1=coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:)));
                  ab1(j)=norm(ad1-cord(j+length(coordinates),:),2);
              end
            
              ad11=find(ab1<0.0001);
              if isempty(ad11)
             cord(length(cord)+1,:)=coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:))); 
              end
                  
           for j=1:length(cord)-length(coordinates)
                  
                  ad2=coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:)));
                  ab2(j)=norm(ad2-cord(j+length(coordinates),:),2);
                  ad_2=coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:)));
              end
              ad22=find(ab2<0.01);
              
              for j=1:length(coordinates)
                  ad3(j)=norm(ad2-cord(j,:),2);
              end
              ad33=find(ad3<0.01);
             
              if isempty(ad22)&isempty(ad33)
             cord(length(cord)+1,:)=coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:)));
              elseif isempty(ad22)& ~isempty(ad33)
             cord(length(cord)+1,:)=coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,1)},:)));
              end
              %% subdividing walls of the first cell

               cord(length(cord)+1,:)=0.5*((coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,1)},:))))...
                  +(coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,1)},:)))));
               cord(length(cord)+1,:)=0.5*((coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,1)},:))))+cord(length(cord),:));
               cord(length(cord)+1,:)=0.5*((coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,1)},:))))+cord(length(cord)-1,:));
              %% walls of the second cell

              cord(length(cord)+1,:)=0.5*((coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:))))...
                  +(coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:)))));
              cord(length(cord)+1,:)=0.5*((coordinates(walls(i,1),:)-0.1*(coordinates(walls(i,1),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:))))+cord(length(cord),:));
               cord(length(cord)+1,:)=0.5*((coordinates(walls(i,2),:)-0.1*(coordinates(walls(i,2),:)-mean(coordinates(CellvertexId{wall2cell(i,2)},:))))+cord(length(cord)-1,:));
              cord_after=length(cord);
              new_cord=cord_after-cord_before;
             
              
              if new_cord==8 
                  adhesive_wall=[adhesive_wall;[walls(i,1),length(cord)-7]];
                  adhesive_wall=[adhesive_wall;[length(cord)-4,length(cord)-1]];
                  adhesive_wall=[adhesive_wall;[length(cord)-5,length(cord)-2]];
                  adhesive_wall=[adhesive_wall;[length(cord)-3,length(cord)]];
                  adhesive_wall=[adhesive_wall;[walls(i,2),length(cord)-6]];
              elseif ~isempty(ad11)
                  arr=find(adhesive_wall(:,:)==walls(i,1));
                  if length(arr)==2 
                      
                       adhesive_wall=[adhesive_wall;[adhesive_wall(arr(1),2),adhesive_wall(arr(2),2)]];
                  else
              
                   adhesive_wall=[adhesive_wall;[walls(i,1),length(coordinates)+ad11]];
                  end
                  adhesive_wall=[adhesive_wall;[length(cord)-4,length(cord)-1]];
                  adhesive_wall=[adhesive_wall;[length(cord)-5,length(cord)-2]];
                  adhesive_wall=[adhesive_wall;[length(cord)-3,length(cord)]];
                  adhesive_wall=[adhesive_wall;[walls(i,2),length(cord)-6]];
              else
                  adhesive_wall=[adhesive_wall;[walls(i,1),length(cord)-6]];
                  adhesive_wall=[adhesive_wall;[length(cord)-4,length(cord)-1]];
                  adhesive_wall=[adhesive_wall;[length(cord)-5,length(cord)-2]];
                  adhesive_wall=[adhesive_wall;[length(cord)-3,length(cord)]];
                  adhesive_wall=[adhesive_wall;[walls(i,2),length(coordinates)+ad22]];
              end
              if ismember(wall2cell(i,1),paliId)&ismember(wall2cell(i,2),paliId)
                  
                  split_wall=[split_wall;adhesive_wall(length(adhesive_wall)-4:length(adhesive_wall),:)];
                  con_point_pal=[con_point_pal;adhesive_wall(length(adhesive_wall)-2,:)];
                  con_point_2_pal=[con_point_2_pal;adhesive_wall(length(adhesive_wall)-1,:);adhesive_wall(length(adhesive_wall)-3,:)];
                  con_point_3_pal=[con_point_3_pal;adhesive_wall(length(adhesive_wall)-4,:);adhesive_wall(length(adhesive_wall),:)];
              elseif (ismember(wall2cell(i,1),epiId)&~ismember(wall2cell(i,2),epiId))|(~ismember(wall2cell(i,1),epiId)&ismember(wall2cell(i,2),epiId))
                  
                  split_wall=[split_wall;adhesive_wall(length(adhesive_wall)-4:length(adhesive_wall),:)];
                  con_point_epi=[con_point_epi;adhesive_wall(length(adhesive_wall)-2,:)];
                  con_point_2_epi=[con_point_2_epi;adhesive_wall(length(adhesive_wall)-1,:);adhesive_wall(length(adhesive_wall)-3,:)];
                  con_point_3_epi=[con_point_3_epi;adhesive_wall(length(adhesive_wall)-4,:);adhesive_wall(length(adhesive_wall),:)];
              elseif ~ismember(wall2cell(i,1),[epiId;paliId])&~ismember(wall2cell(i,2),[epiId;paliId])
                  
                  split_wall=[split_wall;adhesive_wall(length(adhesive_wall)-4:length(adhesive_wall),:)];
                  con_point_spongy=[con_point_spongy;adhesive_wall(length(adhesive_wall)-2,:)];
                  con_point_2_spongy=[con_point_2_spongy;adhesive_wall(length(adhesive_wall)-1,:);adhesive_wall(length(adhesive_wall)-3,:)];
                  con_point_3_spongy=[con_point_3_spongy;adhesive_wall(length(adhesive_wall)-4,:);adhesive_wall(length(adhesive_wall),:)];
              elseif (ismember(wall2cell(i,1),[paliId])&~ismember(wall2cell(i,2),[epiId;paliId]))|(ismember(wall2cell(i,2),[paliId])&~ismember(wall2cell(i,1),[epiId;paliId]))
                  split_wall=[split_wall;adhesive_wall(length(adhesive_wall)-4:length(adhesive_wall),:)];
                  con_point_pal_spongy=[con_point_pal_spongy;adhesive_wall(length(adhesive_wall)-2,:)];
                  con_point_2_pal_spongy=[con_point_2_pal_spongy;adhesive_wall(length(adhesive_wall)-1,:);adhesive_wall(length(adhesive_wall)-3,:)];
                  con_point_3_pal_spongy=[con_point_3_pal_spongy;adhesive_wall(length(adhesive_wall)-4,:);adhesive_wall(length(adhesive_wall),:)];
             
              end
            
              adhesive_wall=unique(adhesive_wall(:,:),'rows');
          a11=find(CellvertexId{wall2cell(i,1)}==walls(i,1));
          a21=find(CellvertexId{wall2cell(i,1)}==walls(i,2));
          a12=find(CellvertexId{wall2cell(i,2)}==walls(i,1));
          a22=find(CellvertexId{wall2cell(i,2)}==walls(i,2));

          ab11=find(CellID{wall2cell(i,1)}==walls(i,1));
          ab21=find(CellID{wall2cell(i,1)}==walls(i,2));
          ab12=find(CellID{wall2cell(i,2)}==walls(i,1));
          ab22=find(CellID{wall2cell(i,2)}==walls(i,2));
              
          % update vertices of first cell
  as=CellID{wall2cell(i,1)};
    if ~isempty(ab11)&~isempty(ab21) 
              if ab11(1)>ab21(1)& ab21(1)~=1
                  if isempty(ad33)
                    CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab21(1)),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab11(1):length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,walls(i,2)];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                  else
                    CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab21(1)-1),length(cord)-4,length(cord)-5,length(cord)-3,length(cord)-6,CellID{wall2cell(i,1)}(ab11(1):length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                  end
              elseif ab11(1)>ab21(1)& ab21(1)==1
                  if isempty(ad33)
                    CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(ab21(1):length(CellID{wall2cell(i,1)})-1),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab21(1))];
                    wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,walls(i,2)];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                  else
                     CellID{wall2cell(i,1)}=[length(cord)-4,length(cord)-5,length(cord)-3,length(cord)-6,CellID{wall2cell(i,1)}(ab21(1)+1:length(CellID{wall2cell(i,1)})-1),length(cord)-1,length(cord)-4];
                     wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                  end
              elseif ab11(1)<ab21(1)& ab11(1)~=1
                  if isempty(ad33)
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab11(1)),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab21(1):length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,walls(i,2)];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                  else
                    CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab11(1)),length(cord)-4,length(cord)-5,length(cord)-3,length(cord)-6,CellID{wall2cell(i,1)}(ab21(1)+1:length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                     wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                  end
              elseif ab11(1)<ab21(1)& ab11(1)==1
                  if isempty(ad33)
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(ab11(1)),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab11(1)+1:length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(ab11(1))];
                    wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,walls(i,2)];
                    for j=1:length(walls) 
                       if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            walls(i,:)
                            walls(j,:)
                            azr=3;
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                  else
                   CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(ab11(1):length(CellID{wall2cell(i,1)})-2),length(cord)-6,length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab11(1))];
                    wall(i,:)=[walls(i,1),length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=walls(i,1);
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                  end
              end
    elseif (~isempty(ab11)&isempty(ab21)) & (~isempty(a11) &~isempty(a21))
              if a11(1)>a21(1)& a21(1)~=1
                  am1=CellID{wall2cell(i,1)}(length(CellID{wall2cell(i,1)})-1);
                  am2=CellID{wall2cell(i,1)}(a21(1));
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab11(1)-1),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab11(1):length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
              elseif a11(1)>a21(1)& a21(1)==1
                  am1=CellID{wall2cell(i,1)}(length(CellID{wall2cell(i,1)})-1);
                  am2=CellID{wall2cell(i,1)}(a21(1));
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(a21(1):length(CellID{wall2cell(i,1)})-1),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(a21(1))];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                         
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                            end
                        
                    end
              elseif a11(1)<a21(1)& a11(1)~=1
                  am1=CellID{wall2cell(i,1)}(ab11(1));
                  am2=CellID{wall2cell(i,1)}(ab11(1)+1);
                  CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab11(1)),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab11(1)+1:length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                    for j=1:length(walls) 
                       if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
              elseif a11(1)<a21(1)& a11(1)==1
                  am1=CellID{wall2cell(i,1)}(a11(1));
                  am2=CellID{wall2cell(i,1)}(a11(1)+1);
                  CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(a11(1)),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(a11(1)+1:length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(a11(1))];
                  
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
                end
                        
             

    elseif (isempty(ab11)& ~isempty(ab21))& (~isempty(a11) &~isempty(a21))
              if a11(1)>a21(1)& a21(1)~=1
                  am1=CellID{wall2cell(i,1)}(ab21(1)+1);
                  am2=CellID{wall2cell(i,1)}(ab21(1));
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab21(1)),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab21(1)+1:length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
              elseif a11(1)>a21(1)& a21(1)==1
                  am1=CellID{wall2cell(i,1)}(ab21(1));
                  am2=CellID{wall2cell(i,1)}(length(CellID{wall2cell(i,1)})-1);
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(ab21(1):length(CellID{wall2cell(i,1)})-1),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab21(1))];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
              elseif a11(1)<a21(1)& a11(1)~=1
                  if isempty(ad33)
                      am1=CellID{wall2cell(i,1)}(ab21(1)-1);
                  am2=CellID{wall2cell(i,1)}(ab21(1));
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab21(1)-1),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab21(1):length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
                  else
                      am1=CellID{wall2cell(i,1)}(ab21(1)-1);
                  am2=CellID{wall2cell(i,1)}(ab21(1)+1);
                   CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(1:ab21(1)-1),length(cord)-4,length(cord)-5,length(cord)-3,length(cord)-6,CellID{wall2cell(i,1)}(ab21(1)+1:length(CellID{wall2cell(i,1)})-1),CellID{wall2cell(i,1)}(1)];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
                  end
              elseif a11(1)<a21(1)& a11(1)==1
                  am1=CellID{wall2cell(i,1)}(length(CellID{wall2cell(i,1)})-1);
                  am2=CellID{wall2cell(i,1)}(ab21(1)-1);
                 CellID{wall2cell(i,1)}=[CellID{wall2cell(i,1)}(ab21(1)-1),length(cord)-4,length(cord)-5,length(cord)-3,CellID{wall2cell(i,1)}(ab21(1)),CellID{wall2cell(i,1)}(ab21(1)-1)];
                    wall(i,:)=[am1,length(cord)-4];
                    wall(length(wall)+1,:)=[length(cord)-4,length(cord)-5];
                    wall(length(wall)+1,:)=[length(cord)-5,length(cord)-3];
                    wall(length(wall)+1,:)=[length(cord)-3,am2];
                    abe=2;
                    for j=1:length(walls) 
                       if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,1),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,1)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=am1;
                            elseif an==2
                            wall(j,ar)=am2;
                            end
                        end
                    end
              end
              
    end
  
      as=CellID{wall2cell(i,1)};
     
      % update vertices of second cell
        az=CellID{wall2cell(i,2)}; 
    if ~isempty(ab12)&~isempty(ab22)
           
           if ab12(1)>ab22(1)& ab22(1)~=1
               
                    if isempty(ad33)                  
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab22(1)-1),[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                    ad=[];
                  for ii=1:length(walls)
            if ismember(wall2cell(i,2),wall2cell(ii,:)) 
                ad=find(~ismember(wall(ii,:),CellID{wall2cell(i,2)}));
                if ~isempty(ad)& length(ad)==1
                  if ad==1
                wall(ii,ad)=length(cord)-7;
                  else
                 wall(ii,ad)=length(cord)-6;     
                  end
                end
             end
         end
   
                    else
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab22(1)-1),[walls(i,2),length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                      wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),walls(i,2)];
                    
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                    end
                       
         
             elseif ab12(1)>ab22(1)& ab22(1)==1
                    if isempty(ad33)
                    CellID{wall2cell(i,2)}=[[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),length(cord)-6];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                    
                    else
                    CellID{wall2cell(i,2)}=[[walls(i,2),length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),walls(i,2)];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),walls(i,2)];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                    
                    end
            
           elseif ab12(1)<ab22(1)& ab12(1)~=1
                    if isempty(ad33)
                       CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab12(1)-1),[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                       wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                    else
                       CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab12(1)-1),[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),walls(i,2)],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                       wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),walls(i,2)];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                    end
                       
          
             elseif ab12(1)<ab22(1)& ab12(1)==1
                    if isempty(ad33)
                    CellID{wall2cell(i,2)}=[[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),length(cord)-7];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                    else
                        CellID{wall2cell(i,2)}=[[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),walls(i,2)],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),length(cord)-7];
                        wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),walls(i,2)];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=walls(i,2);
                            end
                        end
                    end
                    end
               
           end
          
    elseif (~isempty(ab12)&isempty(ab22))& (~isempty(a12) &~isempty(a22))
           
           if a12(1)>a22(1)& a22(1)~=1
               
                    if new_cord==8,
                  
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab12(1)-2),[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                    else
                     CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab12(1)-2),[length(coordinates)+ad22,length(cord),length(cord)-2,length(cord)-1,length(cord)-6],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                     wall(length(wall)+1,:)=[[length(cord)-6,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(coordinates)+ad22];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-6;
                            elseif an==2
                            wall(j,ar)=length(coordinates)+ad22;
                            end
                        end
                    end
                    end
                       
         
             elseif a12(1)>a22(1)& a22(1)==1
                if new_cord==8
                    CellID{wall2cell(i,2)}=[[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),length(cord)-6];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                else
                    CellID{wall2cell(i,2)}=[[length(coordinates)+ad22,length(cord),length(cord)-2,length(cord)-1,length(cord)-6],CellID{wall2cell(i,2)}(ab12(1)+1:length(CellID{wall2cell(i,2)})-1),length(coordinates)+ad22];
                    wall(length(wall)+1,:)=[[length(cord)-6,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(coordinates)+ad22];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-6;
                            elseif an==2
                            wall(j,ar)=length(coordinates)+ad22;
                            end
                        end
                    end
                end
            
           elseif a12(1)<a22(1)& a12(1)~=1
               
                     if new_cord==8
                     
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab12(1)-1),[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab12(1)+2:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                      wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                     else
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab12(1)-1),[length(cord)-6,length(cord)-1,length(cord)-2,length(cord),length(coordinates)+ad22],CellID{wall2cell(i,2)}(ab12(1)+2:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                      wall(length(wall)+1,:)=[[length(cord)-6,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(coordinates)+ad22];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-6;
                            elseif an==2
                            wall(j,ar)=length(coordinates)+ad22;
                            end
                        end
                    end
                     end
          
             elseif a12(1)<a22(1)& a12(1)==1
                 if new_cord==8
                    CellID{wall2cell(i,2)}=[[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab12(1)+2:length(CellID{wall2cell(i,2)})-1),length(cord)-7];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                 else
                   CellID{wall2cell(i,2)}=[[length(cord)-6,length(cord)-1,length(cord)-2,length(cord),length(coordinates)+ad22],CellID{wall2cell(i,2)}(ab12(1)+2:length(CellID{wall2cell(i,2)})-1),length(cord)-6];
                   wall(length(wall)+1,:)=[[length(cord)-6,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(coordinates)+ad22];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-6;
                            elseif an==2
                            wall(j,ar)=length(coordinates)+ad22;
                            end
                        end
                    end
                 end
               
           end
   
   elseif (isempty(ab12)&~isempty(ab22))& (~isempty(a12) &~isempty(a22))
           
           if a12(1)>a22(1)& a22(1)~=1
               
                    if new_cord==8,
                  
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab22(1)-1),[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab22(1)+2:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                    wall(length(wall)+1,:)=[[length(cord)-7,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                    
                    elseif isempty(ad33)
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab22(1)-1),[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(coordinates)+ad11],CellID{wall2cell(i,2)}(ab22(1)+2:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                      wall(length(wall)+1,:)=[[length(coordinates)+ad11,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(coordinates)+ad11;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                    else
                      CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab22(1)-1),[ad33,length(cord),length(cord)-2,length(cord)-1,length(coordinates)+ad11],CellID{wall2cell(i,2)}(ab22(1)+2:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                      wall(length(wall)+1,:)=[[length(coordinates)+ad11,length(cord)-1]];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),ad33];
                    for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(coordinates)+ad11;
                            elseif an==2
                            wall(j,ar)=ad33;
                            end
                        end
                    end
                    
                    end
         
             elseif a12(1)>a22(1)& a22(1)==1
                 if new_cord==8,
                    CellID{wall2cell(i,2)}=[[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(cord)-7],CellID{wall2cell(i,2)}(ab22(1)+2:length(CellID{wall2cell(i,2)})-1),length(cord)-6];
                    wall(length(wall)+1,:)=[length(cord)-7,length(cord)-1];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                 elseif isempty(ad33)
                   CellID{wall2cell(i,2)}=[[length(cord)-6,length(cord),length(cord)-2,length(cord)-1,length(coordinates)+ad11],CellID{wall2cell(i,2)}(ab22(1)+2:length(CellID{wall2cell(i,2)})-1),length(cord)-6];
                   wall(length(wall)+1,:)=[length(coordinates)+ad11,length(cord)-1];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(coordinates)+ad11;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                 else
                   CellID{wall2cell(i,2)}=[[ad33,length(cord),length(cord)-2,length(cord)-1,length(coordinates)+ad11],CellID{wall2cell(i,2)}(ab22(1)+2:length(CellID{wall2cell(i,2)})-1),ad33];
                   wall(length(wall)+1,:)=[length(coordinates)+ad11,length(cord)-1];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),ad33];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(coordinates)+ad11;
                            elseif an==2
                            wall(j,ar)=ad33;
                            end
                        end
                    end
                 end
                 
                    
            
           elseif a12(1)<a22(1)& a12(1)~=1
               if new_cord==8,
                    
                     CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab22(1)-2),[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                     wall(length(wall)+1,:)=[length(cord)-7,length(cord)-1];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
               else
                   CellID{wall2cell(i,2)}=[CellID{wall2cell(i,2)}(1:ab22(1)-2),[length(coordinates)+ad11,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),CellID{wall2cell(i,2)}(1)];
                    wall(length(wall)+1,:)=[length(coordinates)+ad11,length(cord)-1];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(coordinates)+ad11;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
               end
               
                     
                       
          
             elseif a12(1)<a22(1)& a12(1)==1
                  if new_cord==8,
                    CellID{wall2cell(i,2)}=[[length(cord)-7,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),length(cord)-7];
                   wall(length(wall)+1,:)=[length(cord)-7,length(cord)-1];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(cord)-7;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                  else
                   CellID{wall2cell(i,2)}=[[length(coordinates)+ad11,length(cord)-1,length(cord)-2,length(cord),length(cord)-6],CellID{wall2cell(i,2)}(ab22(1)+1:length(CellID{wall2cell(i,2)})-1),length(coordinates)+ad11];
                   wall(length(wall)+1,:)=[length(coordinates)+ad11,length(cord)-1];
                    wall(length(wall)+1,:)=[length(cord)-1,length(cord)-2];
                    wall(length(wall)+1,:)=[length(cord)-2,length(cord)];
                    wall(length(wall)+1,:)=[length(cord),length(cord)-6];
                     for j=1:length(walls) 
                        if (ismember(numberofcells,wall2cell(j,:))& ismember(wall2cell(i,2),wall2cell(j,:)))...
                                & (~isempty(find(ismember(walls(j,:),walls(i,:))))&~isempty(find(~ismember(walls(j,:),CellID{wall2cell(i,2)}))))
                            ar=find(ismember(walls(j,:),walls(i,:)));
                            an=find(ismember(walls(i,:),walls(j,:)));
                            if an==1
                            wall(j,ar)=length(coordinates)+ad11;
                            elseif an==2
                            wall(j,ar)=length(cord)-6;
                            end
                        end
                    end
                  end
               
           end
          
       az=CellID{wall2cell(i,2)};      
    end
    
           AA=[AA;walls(i,:)];
           BB=[BB;wall2cell(i,:)];
           w2c(length(w2c)+1:length(wall),1)=wall2cell(i,1);
            w2c(length(w2c)-6:length(w2c),2)=wall2cell(i,2);
            WO_1=[WO_1,i,length(wall)-6:length(wall)-4];
            WO_2=[WO_2,length(wall)-3:length(wall)];

                  split_turgor_1=[split_turgor_1,[i,length(wall)-6:length(wall)-4]];
                  split_turgor_2=[split_turgor_2,[length(wall)-3:length(wall)]];

        end
         
       
     end

            ADH=adhesive_wall;
        for i=1:length(adhesive_wall)
            add=[];
            for j=1:length(adhesive_wall)
                if ismember(adhesive_wall(i,1),adhesive_wall(j,:))
                    add=[add,adhesive_wall(j,:)];
                end
            end
            adw{i}=unique([adhesive_wall(i,:),add]);
           if length(adw{i})==3
               
               ADH(length(ADH)+1,:)=[adw{i}(2),adw{i}(3)];
          
              
           end
            
        end
        adhesive_wall= unique(ADH,'rows');
        
        for i=1:length(adhesive_wall)
        
        ll(i)=norm(cord(adhesive_wall(i,1),:)-cord(adhesive_wall(i,2),:),2);
           
          ad_direction(i,:)=(cord(adhesive_wall(i,1),:)-cord(adhesive_wall(i,2),:))/ll(i); 
        end
           
          codd=[];
            codd=cord;
         
        for i=1:length(adhesive_wall)
            add=[];
            for j=1:length(adhesive_wall)
                if ismember(adhesive_wall(i,1),adhesive_wall(j,:))
                    add=[add,adhesive_wall(j,:)];
                end
            end
            adw{i}=unique([adhesive_wall(i,:),add]);
           if length(adw{i})==3
               cord(adw{i}(1),:)=mean(codd([adw{i}(1);adw{i}(2);adw{i}(3)],:));
               cord(adw{i}(2),:)=mean(codd([adw{i}(1);adw{i}(2);adw{i}(3)],:));
               cord(adw{i}(3),:)=mean(codd([adw{i}(1);adw{i}(2);adw{i}(3)],:));
              
           elseif length(adw{i})==2
               cord(adw{i}(1),:)=mean(codd([adw{i}(1);adw{i}(2)],:));
               cord(adw{i}(2),:)=mean(codd([adw{i}(1);adw{i}(2)],:));
              
           end
            
        end
        for i=1:length(adhesive_wall)
            if ismember(adhesive_wall(i,1),left_boundary)| ismember(adhesive_wall(i,2),left_boundary)
                cord(adhesive_wall(i,:),1)=min(cord(:,1));
             
            end
            if ismember(adhesive_wall(i,1),right_boundary)| ismember(adhesive_wall(i,2),right_boundary)
                cord(adhesive_wall(i,:),1)=max(cord(:,1));
            end
            if ismember(adhesive_wall(i,1),bottom_boundaryy)| ismember(adhesive_wall(i,2),bottom_boundaryy)
                cord(adhesive_wall(i,:),2)=min(cord(:,2));
               
            end
            if ismember(adhesive_wall(i,1),top_boundaryy)| ismember(adhesive_wall(i,2),top_boundaryy)
                cord(adhesive_wall(i,:),2)=max(cord(:,2));
            end
        end
       coordinates=cord;
        CellvertexId=CellID;
        walls=wall;
        wall2cell=w2c;

        
coordinates=cord;
 
    
    counter=0;
   
   for i=1:length(CellvertexId)
       for j=1:length(CellvertexId{i})-1
           counter=counter+1;
           wall1(counter,:)=[CellvertexId{i}(j),CellvertexId{i}(j+1)];
           end
      
   end
w2c1=numberofcells*ones(length(wall1),2);


   for i=1:length(wall1)
       index=[];
      for j=1:length(CellvertexId)
          if ~isempty(intersect(coordinates(wall1(i,1),:),coordinates(CellvertexId{j},:),'rows'))& ~isempty(intersect(coordinates(wall1(i,2),:),coordinates(CellvertexId{j},:),'rows'))
       index=[index,j];
          end
      end
       if length(index)==2
       w2c1(i,:)=index;
       else
           w2c1(i,1)=index;
       end
   end

    for i=1:length(walls)
           l_n(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);
        end
        for i=1:length(CellvertexId)
         Cellarea(i)=polyarea(coordinates(CellvertexId{i},1),coordinates(CellvertexId{i},2));
        end
cd(string)
      save con_point_pal con_point_pal;
      save con_point_2_pal con_point_2_pal;
      save con_point_3_pal con_point_3_pal;
      
      save con_point_epi con_point_epi;
      save con_point_2_epi con_point_2_epi;
      save con_point_3_epi con_point_3_epi;
      
      save con_point_spongy con_point_spongy;
      save con_point_2_spongy con_point_2_spongy;
      save con_point_3_spongy con_point_3_spongy;
      
      save con_point_pal_spongy con_point_pal_spongy;
      save con_point_2_pal_spongy con_point_2_pal_spongy;
      save con_point_3_pal_spongy con_point_3_pal_spongy;
      cd(string11)
 