load cord %% coordinates of the vertexId for each of the tissues
load CellId %% contains the cellvertexId of each  
load PID %% information about which cell is a palisade in each tissue
load EID %% information about which cell is a epidermal cell in each tissue
load WALL %% information about which vertices defines a wall
load W2C %%

for i=1:length(CellId)  % For each geometry
 
 % Initialization   
 coordinates=[];
 CellvertexId=[];   
 epiId=[];          
 paliId=[];
 walls=[];
 wall2cell=[];
 spongyvertex=[];
 spongyId=[];
 V_walls=[];        % Will contain all vertices that contains internal boundaries of pallisade parenchyma 
 
 % Assign values to initialized vectors
 coordinates=cord{i};
 CellvertexId=CellId{i};
 epiId=EID{i};
 paliId=PID{i};
 walls=WALL{i};
 wall2cell=W2C{i};
 
 for j=1:length(CellvertexId)
   x=(coordinates(CellvertexId{j},1));
   y=(coordinates(CellvertexId{j},2));
%    patch(coordinates(CellvertexId{i},1),coordinates(CellvertexId{i},2),'g')
 subplot(3,1,i)  
plot(x,y)
   hold on
end
end



load coordinates
load epiId
load CellvertexId
load paliId
for j=1:length(CellvertexId)
    
        if ismember(j,epiId)
            patch(coordinates(CellvertexId{j},1),coordinates(CellvertexId{j},2),'w','linewidth',0.01)

        elseif ismember(j,paliId)
            patch(coordinates(CellvertexId{j}(:),1),coordinates(CellvertexId{j}(:),2),'g','linewidth',1)
        else

            patch(coordinates(CellvertexId{j},1),coordinates(CellvertexId{j},2),'c')
            hold on
        end
end

