function [coordinates,dimension,numberofcells,walls,wall2cell,l_n,Cellarea,CellvertexId,t,l_n_0,y,epiId,paliId,KK,geom,adhesive_wall,split_wall,split_turgor_1,split_turgor_2,...
    left_boundary,right_boundary,az_top,az_top_2,az_bottom,az_bottom_2,con_point_pal,con_point_2_pal,con_point_3_pal,con_point_epi,con_point_2_epi,con_point_3_epi,...
    con_point_spongy,con_point_2_spongy,con_point_3_spongy,con_point_pal_spongy,con_point_2_pal_spongy,con_point_3_pal_spongy]=SPLIT(ap,ar,dr,l_n_max_2_l_n_0,geom,string,string11)
cd(string)

load coordinates
load CellvertexId
load walls
load wall2cell
load l_n
load epiId
load paliId
load KK
load adhesive_wall
load split_wall
load split_turgor_1
load split_turgor_2
load left_boundary 
load right_boundary 
load az_top 
load az_top_2 
load az_bottom 
load az_bottom_2

load con_point_pal 
load con_point_2_pal 
load con_point_3_pal 

load con_point_epi 
load con_point_2_epi 
load con_point_3_epi 

load con_point_spongy 
load con_point_2_spongy 
load con_point_3_spongy 

load con_point_pal_spongy 
load con_point_2_pal_spongy 
load con_point_3_pal_spongy 
cd(string11)

%% remove the comments if only a portion of the walls need to be separated
% SP=split_wall;
% split_wall=[];
% rand('state',5) % the state of rand allows generating various porosities
% split_wall=SP(unique(randi(length(SP),length(SP),1)),:);

ABD=[];
for i=2:2:length(paliId)
    ABD=[ABD,CellvertexId{paliId(i)}];
end
con_left=min(coordinates(:,1));
con_bottom=min(coordinates(:,2));
numberofcells=length(CellvertexId)+1;
dimension=2;
  wall2cell(split_turgor_1,2)=numberofcells+1;
  wall2cell(split_turgor_2,1)=numberofcells+1;
  wall2cell(split_turgor_1,1)=numberofcells+2;
  wall2cell(split_turgor_2,2)=numberofcells+2;
  for i=1:length(walls)
      if ismember(numberofcells,wall2cell(i,:))&ismember(wall2cell(i,1),paliId)
          wall2cell(i,2)=numberofcells+1;
      elseif ismember(numberofcells,wall2cell(i,:))&ismember(wall2cell(i,2),paliId)
          wall2cell(i,1)=numberofcells+1;
      end
  end

for i=1:length(CellvertexId)
         Cellarea(i)=polyarea(coordinates(CellvertexId{i},1),coordinates(CellvertexId{i},2));
end
Chloro_surf=[];
 for i=1:length(adhesive_wall)
            
           
           if ismember(adhesive_wall(i,:),[split_wall])& (ismember(adhesive_wall(i,1),[con_point_3_epi])&ismember(adhesive_wall(i,2),[con_point_3_epi]))
              g=1
         K_ad(i)=0;
         Chloro_surf=[Chloro_surf;(adhesive_wall(i,:))'];
           elseif ismember(adhesive_wall(i,:),[split_wall])& (ismember(adhesive_wall(i,1),[con_point_2_epi])&ismember(adhesive_wall(i,2),[con_point_2_epi]))
               K_ad(i)=50;  
                   
           elseif ismember(adhesive_wall(i,:),[split_wall])& (ismember(adhesive_wall(i,1),[con_point_3_pal])&ismember(adhesive_wall(i,2),[con_point_3_pal])) 
               K_ad(i)=0;
               g=2
               Chloro_surf=[Chloro_surf;(adhesive_wall(i,:))'];
         
          elseif ismember(adhesive_wall(i,:),[split_wall])& (ismember(adhesive_wall(i,1),[con_point_2_pal])&ismember(adhesive_wall(i,2),[con_point_2_pal])) 
             K_ad(i)=0; 
             g=3
          Chloro_surf=[Chloro_surf;(adhesive_wall(i,:))'];
          elseif ismember(adhesive_wall(i,:),[split_wall])& (ismember(adhesive_wall(i,1),[con_point_pal([1:3:end],:)])&ismember(adhesive_wall(i,2),[con_point_pal([1:2:end],:)]))
          K_ad(i)=0;
          g=4
          Chloro_surf=[Chloro_surf;(adhesive_wall(i,:))'];

elseif ismember(adhesive_wall(i,:),[split_wall])& (ismember(adhesive_wall(i,1),[con_point_3_pal_spongy])&ismember(adhesive_wall(i,2),[con_point_3_pal_spongy]))
          K_ad(i)=0; 
          g=5
          Chloro_surf=[Chloro_surf;(adhesive_wall(i,:))'];
           elseif ismember(adhesive_wall(i,:),[split_wall])& (ismember(adhesive_wall(i,1),[con_point_2_pal_spongy])&ismember(adhesive_wall(i,2),[con_point_2_pal_spongy]))
         K_ad(i)=100; 
           else
          K_ad(i)=100; 
           end
           if ismember(adhesive_wall(i,:),[split_wall])&((ismember(adhesive_wall(i,1),ABD)&~ismember(adhesive_wall(i,2),ABD))|(ismember(adhesive_wall(i,2),ABD)&~ismember(adhesive_wall(i,1),ABD)))
          K_ad(i)=0; 
          Chloro_surf=[Chloro_surf;(adhesive_wall(i,:))'];
           end
          
end       

%% assigning turgore pressure to the cells, spring constant to the walls  and damping coefficient for the matrix

turgorpressure(numberofcells,1)=0;
turgorpressure(1:numberofcells-1,1)=1;
turgorpressure(numberofcells+1,1)=0.9;
turgorpressure(numberofcells+2,1)=0.9;

A0=mean(Cellarea); % average cell area of the initial cells
drag=dr; %drag coefficient 
l_n_0=l_n;% initial resting length
l_nmax=l_n_max_2_l_n_0*l_n_0; %setting the maximum resting length of the walls
%% initializing the variables
aml=[];
tau1=200000;
tau=tau1;
%%
velocity=zeros(length(coordinates),dimension);
tstart=0;
tfinal=2000;
at=10^(-ar);% absolute tolerance
rt=10^(-(ar+1));%relative tolerance
pr=1;% initialing turgore pressure
tc=100000;% time constant for torgore pressure to reach maximum
pmax=ap;
y0=[coordinates(:,1);coordinates(:,2);l_n;pr];% intial conditions for the ode solver
options = odeset('RelTol',rt,'AbsTol',at,'events',@events,'stats','on','MaxOrder',1,'BDF','on');
poreId=[];% initialzing pore cells
%% beginning of the solution
for j=1:1,
BDc=[]; %initializing the boundary cells

ABD=1:length(coordinates);
stopc=ABD(find(~ismember(ABD,[left_boundary,right_boundary,az_top ,az_top_2,az_bottom,az_bottom_2])));
savetime=[[tstart:100:tfinal]];%,[1250:1000:10000],[11000:25000:1000000],[1025000:250000:tfinal]];
[t,y]=ode15s(@f,[savetime],y0,options); % the ODE solver 
end
%% defining the ODE function to be solved

function dydt=f(t,y)
    
   %% initializing the parameters at every time step
 b=[];
 force=zeros(length(coordinates),dimension);
 pf=zeros(length(coordinates),dimension);
 Tf=zeros(length(coordinates),dimension);
 coordinates=[y(1:1*length(coordinates)),y(1*length(coordinates)+1:2*length(coordinates))];% new coordinates
 coordinates(left_boundary,1)=con_left;
 
%Calculate new Length and direction of walls

for i=1:length(walls)
    l(i)=norm(coordinates(walls(i,1),:)-coordinates(walls(i,2),:),2);
    direction(i,:)=(coordinates(walls(i,1),:)-coordinates(walls(i,2),:))/l(i);
    normal_direction(i,1)=direction(i,2);
    normal_direction(i,2)=-direction(i,1);
    Degree1(i)= atan((coordinates(walls(i,2),2)-coordinates(walls(i,1),2))/(coordinates(walls(i,2),1)-coordinates(walls(i,1),1)));

    Fturgor=(turgorpressure(wall2cell(i,2))-turgorpressure(wall2cell(i,1)))*l(i)*(normal_direction(i,:));
    
%% tension force  
b(i)=0;
Ftension=KK(i)*(l(i)-l_n(i))*direction(i,:);         
    
 %% net force

pf(walls(i,1),:)=pf(walls(i,1),:)+0.5*Fturgor; 
pf(walls(i,2),:)=pf(walls(i,2),:)+0.5*Fturgor ;
Tf(walls(i,1),:)=Tf(walls(i,1),:)-Ftension; 
Tf(walls(i,2),:)=Tf(walls(i,2),:)+Ftension;

kr(i)=0;

end
% %   
for i=1:length(adhesive_wall)
    ll(i)=1+norm(coordinates(adhesive_wall(i,1),:)-coordinates(adhesive_wall(i,2),:),2);             
    Tf(adhesive_wall(i,1),:)=Tf(adhesive_wall(i,1),:)-K_ad(i)*(coordinates(adhesive_wall(i,1),:)-coordinates(adhesive_wall(i,2),:))/ll(i); 
    Tf(adhesive_wall(i,2),:)=Tf(adhesive_wall(i,2),:)+K_ad(i)*(coordinates(adhesive_wall(i,1),:)-coordinates(adhesive_wall(i,2),:))/ll(i);
end

force=pf+Tf;    
force(left_boundary,1)=0;
force([az_bottom],2)=0;
force(right_boundary,1)=0;
force([az_top,az_top_2],2)=0; 

velocity(:,1)=force(:,1)/drag;
velocity(:,2)=force(:,2)/drag;
velocity(left_boundary,1)=mean(velocity(left_boundary,1));
velocity(right_boundary,1)=mean(velocity(right_boundary,1));
velocity(az_bottom_2,2)=mean(velocity(az_bottom_2,2));
velocity(az_top_2,2)=mean(velocity(az_top_2,2));
velocity(az_bottom,2)=mean(velocity(az_bottom,2));
velocity(az_top,2)=mean(velocity(az_top,2));

p=0;
dydt=[velocity(:,1);velocity(:,2);b(:);p];
    
% 
end
 %% saving the time history of forces on vertices
function [value,isterminal,direction] = events(t,y)
   for i=1:length( CellvertexId),   
     Cellarea(i)=polyarea(coordinates(CellvertexId{i}(:),1),coordinates(CellvertexId{i}(:),2));
    end

areacheck=(mean(Cellarea)-5*A0);
NV=norm(velocity(stopc,:));
value=mean(NV)-0.0001;
t1=t;

isterminal = ones(1,1);
direction =-ones(1,1);

end   % End nested function events

end
